"""
A golf course.

https://schema.org/GolfCourse
"""

from datetime import *
from copy import deepcopy
from typing import *
from time import *

from typing_extensions import TypedDict, NotRequired
from pydantic import *


from schorg.schema_org_obj import SchemaOrgObj, SchemaOrgBase


class GolfCourseInheritedProperties(TypedDict):
    """A golf course.

    References:
        https://schema.org/GolfCourse
    Note:
        Model Depth 5
    Attributes:
    """


class GolfCourseProperties(TypedDict):
    """A golf course.

    References:
        https://schema.org/GolfCourse
    Note:
        Model Depth 5
    Attributes:
    """


class GolfCourseAllProperties(
    GolfCourseInheritedProperties, GolfCourseProperties, TypedDict
):
    pass


class GolfCourseBaseModel(SchemaOrgBase):
    id_: Optional[Any] = Field(default="GolfCourse", alias="@id")
    context_: Optional[Any] = Field(default=None, alias="@context")
    graph_: Optional[Any] = Field(default=None, alias="@graph")

    class Config:
        ...


def create_schema_org_model(
    type_: Union[
        GolfCourseProperties, GolfCourseInheritedProperties, GolfCourseAllProperties
    ] = GolfCourseAllProperties
) -> Type[SchemaOrgBase]:
    model = create_model_from_typeddict(type_, __base__=SchemaOrgBase)
    model.__name__ = "GolfCourse"
    return model


GolfCourse = create_schema_org_model()


def create_golfcourse_model(
    model: Union[
        GolfCourseProperties, GolfCourseInheritedProperties, GolfCourseAllProperties
    ]
):
    _type = deepcopy(GolfCourseAllProperties)
    for k in model.__annotations__.keys():
        if k not in _type.__annotations__:
            del _type.__annotations__[k]
    return create_schema_org_model(type_=_type)


def schema_json(model: GolfCourseAllProperties):
    pydantic_type = create_golfcourse_model(model=model)
    return pydantic_type(model).schema_json()
