"""
A diet focused on reduced fat and cholesterol intake.

https://schema.org/LowFatDiet
"""

from datetime import *
from copy import deepcopy
from typing import *
from time import *

from typing_extensions import TypedDict, NotRequired
from pydantic import *


from schorg.schema_org_obj import SchemaOrgObj, SchemaOrgBase


class LowFatDietInheritedProperties(TypedDict):
    """A diet focused on reduced fat and cholesterol intake.

    References:
        https://schema.org/LowFatDiet
    Note:
        Model Depth 5
    Attributes:
    """


class LowFatDietProperties(TypedDict):
    """A diet focused on reduced fat and cholesterol intake.

    References:
        https://schema.org/LowFatDiet
    Note:
        Model Depth 5
    Attributes:
    """


class LowFatDietAllProperties(
    LowFatDietInheritedProperties, LowFatDietProperties, TypedDict
):
    pass


class LowFatDietBaseModel(SchemaOrgBase):
    id_: Optional[Any] = Field(default="LowFatDiet", alias="@id")
    context_: Optional[Any] = Field(default=None, alias="@context")
    graph_: Optional[Any] = Field(default=None, alias="@graph")

    class Config:
        ...


def create_schema_org_model(
    type_: Union[
        LowFatDietProperties, LowFatDietInheritedProperties, LowFatDietAllProperties
    ] = LowFatDietAllProperties
) -> Type[SchemaOrgBase]:
    model = create_model_from_typeddict(type_, __base__=SchemaOrgBase)
    model.__name__ = "LowFatDiet"
    return model


LowFatDiet = create_schema_org_model()


def create_lowfatdiet_model(
    model: Union[
        LowFatDietProperties, LowFatDietInheritedProperties, LowFatDietAllProperties
    ]
):
    _type = deepcopy(LowFatDietAllProperties)
    for k in model.__annotations__.keys():
        if k not in _type.__annotations__:
            del _type.__annotations__[k]
    return create_schema_org_model(type_=_type)


def schema_json(model: LowFatDietAllProperties):
    pydantic_type = create_lowfatdiet_model(model=model)
    return pydantic_type(model).schema_json()
