"""
A plumbing service.

https://schema.org/Plumber
"""

from datetime import *
from copy import deepcopy
from typing import *
from time import *

from typing_extensions import TypedDict, NotRequired
from pydantic import *


from schorg.schema_org_obj import SchemaOrgObj, SchemaOrgBase


class PlumberInheritedProperties(TypedDict):
    """A plumbing service.

    References:
        https://schema.org/Plumber
    Note:
        Model Depth 5
    Attributes:
    """


class PlumberProperties(TypedDict):
    """A plumbing service.

    References:
        https://schema.org/Plumber
    Note:
        Model Depth 5
    Attributes:
    """


class PlumberAllProperties(PlumberInheritedProperties, PlumberProperties, TypedDict):
    pass


class PlumberBaseModel(SchemaOrgBase):
    id_: Optional[Any] = Field(default="Plumber", alias="@id")
    context_: Optional[Any] = Field(default=None, alias="@context")
    graph_: Optional[Any] = Field(default=None, alias="@graph")

    class Config:
        ...


def create_schema_org_model(
    type_: Union[
        PlumberProperties, PlumberInheritedProperties, PlumberAllProperties
    ] = PlumberAllProperties
) -> Type[SchemaOrgBase]:
    model = create_model_from_typeddict(type_, __base__=SchemaOrgBase)
    model.__name__ = "Plumber"
    return model


Plumber = create_schema_org_model()


def create_plumber_model(
    model: Union[PlumberProperties, PlumberInheritedProperties, PlumberAllProperties]
):
    _type = deepcopy(PlumberAllProperties)
    for k in model.__annotations__.keys():
        if k not in _type.__annotations__:
            del _type.__annotations__[k]
    return create_schema_org_model(type_=_type)


def schema_json(model: PlumberAllProperties):
    pydantic_type = create_plumber_model(model=model)
    return pydantic_type(model).schema_json()
