"""
A trial that takes place at a single center.

https://schema.org/SingleCenterTrial
"""

from datetime import *
from copy import deepcopy
from typing import *
from time import *

from typing_extensions import TypedDict, NotRequired
from pydantic import *


from schorg.schema_org_obj import SchemaOrgObj, SchemaOrgBase


class SingleCenterTrialInheritedProperties(TypedDict):
    """A trial that takes place at a single center.

    References:
        https://schema.org/SingleCenterTrial
    Note:
        Model Depth 6
    Attributes:
    """


class SingleCenterTrialProperties(TypedDict):
    """A trial that takes place at a single center.

    References:
        https://schema.org/SingleCenterTrial
    Note:
        Model Depth 6
    Attributes:
    """


class SingleCenterTrialAllProperties(
    SingleCenterTrialInheritedProperties, SingleCenterTrialProperties, TypedDict
):
    pass


class SingleCenterTrialBaseModel(SchemaOrgBase):
    id_: Optional[Any] = Field(default="SingleCenterTrial", alias="@id")
    context_: Optional[Any] = Field(default=None, alias="@context")
    graph_: Optional[Any] = Field(default=None, alias="@graph")

    class Config:
        ...


def create_schema_org_model(
    type_: Union[
        SingleCenterTrialProperties,
        SingleCenterTrialInheritedProperties,
        SingleCenterTrialAllProperties,
    ] = SingleCenterTrialAllProperties
) -> Type[SchemaOrgBase]:
    model = create_model_from_typeddict(type_, __base__=SchemaOrgBase)
    model.__name__ = "SingleCenterTrial"
    return model


SingleCenterTrial = create_schema_org_model()


def create_singlecentertrial_model(
    model: Union[
        SingleCenterTrialProperties,
        SingleCenterTrialInheritedProperties,
        SingleCenterTrialAllProperties,
    ]
):
    _type = deepcopy(SingleCenterTrialAllProperties)
    for k in model.__annotations__.keys():
        if k not in _type.__annotations__:
            del _type.__annotations__[k]
    return create_schema_org_model(type_=_type)


def schema_json(model: SingleCenterTrialAllProperties):
    pydantic_type = create_singlecentertrial_model(model=model)
    return pydantic_type(model).schema_json()
